## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
## 
## CvEventManager
## This class is passed an argsList from CvAppInterface.onEvent
## The argsList can contain anything from mouse location to key info
## The EVENTLIST that are being notified can be found

from CvPythonExtensions import *
from zPromotions import *

import CvEventManager
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser

gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

class CustomEventManager(CvEventManager.CvEventManager):
	class promos(receive):
		def __init__(self):
			# Place Your Promotion Info Here
			self.addPromoType("PROMOTION_COMBAT5", "PROMO_AIR_CARRIER", 100, [], [], [], True, False, 1)


	def onCombatResult(self, argsList):
		pWinner,pLoser = argsList
		if pWinner.canAcquirePromotionAny():
			self.promos().doReceive(pWinner, pLoser, None, pLoser.getX(), pLoser.getY(), ["PROMO_COMBAT", "PROMO_COMBAT_PLOT", "PROMO_LOSER"])
		CvEventManager.CvEventManager().onCombatResult(argsList)	#Call the default function

	def onUnitMove(self, argsList):
		'unit move'
		pPlot,pUnit = argsList
		player = PyPlayer(pUnit.getOwner())
		unitInfo = PyInfo.UnitInfo(pUnit.getUnitType())

		if pUnit.canAcquirePromotionAny():
			self.promos().doReceive(pUnit, None, pPlot, pPlot.getX(), pPlot.getY(), ["PROMO_PLOT", "PROMO_CITY_BUILDING", "PROMO_NEUTRAL"])
			if pPlot.getOwner() != -1:
				self.promos().doReceive(pUnit, None, pPlot, pPlot.getX(), pPlot.getY(), ["PROMO_HOMELAND", "PROMO_BARBARIAN", "PROMO_VASSAL", "PROMO_MASTER", "PROMO_FRIENDLY", "PROMO_ENEMY", "PROMO_HOSTILE"])
			if pPlot.isCity():
				self.promos().doReceive(pUnit, None, pPlot, pPlot.getX(), pPlot.getY(), ["PROMO_CITY_BUILDING"])
		CvEventManager.CvEventManager().onUnitMove(argsList)	#Call the default function

	def onUnitBuilt(self, argsList):
		'Unit Completed'
		city = argsList[0]
		unit = argsList[1]
		if unit.canAcquirePromotionAny():
			self.promos().doReceive(unit, None, unit.plot(), unit.getX(), unit.getY(), ["PROMO_BUILT"])
		CvEventManager.CvEventManager().onUnitBuilt(argsList)	#Call the default function

	def onUnitBuilt(self, argsList):
		'Unit Completed'
		city = argsList[0]
		unit = argsList[1]
		if unit.canAcquirePromotionAny():
			self.promos().doReceive(unit, None, unit.plot(), unit.getX(), unit.getY(), ["PROMO_BUILT"])
		CvEventManager.CvEventManager().onUnitBuilt(argsList)	#Call the default function

	def onUnitSelected(self, argsList):
		'Unit Selected'
		unit = argsList[0]
		player = gc.getPlayer(unit.getOwner())

		if unit.canAcquirePromotionAny():
			if unit.specialCargo() == gc.getInfoTypeForString("SPECIALUNIT_FIGHTER"):
				self.promos().doReceive(unit, None, None, unit.getX(), unit.getY(), ["PROMO_AIR_CARRIER"])
		CvEventManager.CvEventManager().onUnitSelected(argsList)	#Call the default function